    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * -------------------------------
    028 * DimensionObjectDescription.java
    029 * -------------------------------
    030 * (C)opyright 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: DimensionObjectDescription.java,v 1.2 2005/10/18 13:31:58 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 13-Jan-2004 : Initial version
    040 *
    041 */
    042
    043package org.jfree.xml.factory.objects;
    044
    045import java.awt.Dimension;
    046import java.awt.geom.Dimension2D;
    047
    048/**
    049 * An object-description for a <code>java.awt.Dimension</code> object.
    050 *
    051 * @author Thomas Morgner
    052 */
    053public class DimensionObjectDescription extends AbstractObjectDescription {
    054
    055    /**
    056     * Creates a new object description.
    057     */
    058    public DimensionObjectDescription() {
    059        super(Dimension.class);
    060        setParameterDefinition("width", Float.class);
    061        setParameterDefinition("height", Float.class);
    062    }
    063
    064    /**
    065     * Creates an object based on the description.
    066     *
    067     * @return The object.
    068     */
    069    public Object createObject() {
    070        final Dimension2D dim = new Dimension();
    071
    072        final float width = getFloatParameter("width");
    073        final float height = getFloatParameter("height");
    074        dim.setSize(width, height);
    075        return dim;
    076    }
    077
    078    /**
    079     * Returns a parameter value as a float.
    080     *
    081     * @param param  the parameter name.
    082     *
    083     * @return The float value.
    084     */
    085    private float getFloatParameter(final String param) {
    086        final Float p = (Float) getParameter(param);
    087        if (p == null) {
    088            return 0;
    089        }
    090        return p.floatValue();
    091    }
    092
    093
    094    /**
    095     * Sets the parameters of this description object to match the supplied object.
    096     *
    097     * @param o  the object (should be an instance of <code>Dimension2D</code>).
    098     *
    099     * @throws ObjectFactoryException if the object is not an instance of <code>Point2D</code>.
    100     */
    101    public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    102        if (!(o instanceof Dimension)) {
    103            throw new ObjectFactoryException("The given object is no java.awt.geom.Dimension2D.");
    104        }
    105
    106        final Dimension dim = (Dimension) o;
    107        final float width = (float) dim.getWidth();
    108        final float height = (float) dim.getHeight();
    109
    110        setParameter("width", new Float(width));
    111        setParameter("height", new Float(height));
    112    }
    113}